export default (

	( option, axios, api = {} ) => {

	/* !!
	 * Response.Data:
	 * => Code
	 * => Data
	 * => Msg
	 *   => 0: No Error
	 *   => -1: Show User
	 *   => -2: Form Valid
	 *   => -3: Un Login
	 * ===== ===== =====
	 */

	window.lock = window.lock == undefined ? false : window.lock;

	// Interceptor For Error
	axios.interceptors.response.use(
		// Response
		(response) => {

			return response;

		},
		(error) => {

			window.lock = false;

			try {
				console.log( 'Axios Error Code :: ' + error.response.code + ' => ', error.response.data );
			}
			catch (e)
			{
				console.log( error );
			}

			return Promise.reject(error);
		}
	);

	const cap = ( method, link, param, config, once ) => {

		if ( once )
		{
			if ( window.lock )
			{
				return;
			}
			window.lock = true;
		}

		return axios[ method ]( link, method == 'get' ? { params: param } : param, config )

			.then( (response) => {

				window.lock = false;

				return response.data;

			});

	}

	['get', 'post', 'put', 'delete'].map( (method) => {

		api[ method ] = ( link, param, config, once ) => {

			return cap( method, link || option.link, param || option.param, config || option.config, once );

		}

	});

	return Object.assign( api, { promise: axios.all, spread: axios.spread } );

})
(
	{
		method: 'get',
		link: '',
		param: {},
		config: {}
	},

	window.axios = require('axios')
)
